'Copyright 2007 TomGaines
'This script shows an example of the reading functions from the CCVControl.dll
'It will generate three text files.
'1. Profile information of a random profile
'2. Series information of a random TV Series
'3. Exemplary Award and Appearances Search 


DatabasePath = ""
'DatabasePath = "D:\Apps\Workspaces\CastCrewViewer\CCViewer\WorkingDatabase.mdb"
if DatabasePath = "" then DatabasePath = InputBox("Enter path to your CCViewer database")
if DatabasePath = "" then wscript.quit

set Viewer = CreateObject("CCVCtrl.Control")

'When using in Profiler Skins:
'JScript: var Viewer = new ActiveXObject("CCVCtrl.Control");
'var ProfileID = "Key_" + "<DP NAME="UPC" Formatted="NO">
'var db = Viewer.OpenDatabase(DatabasePath)
'var Profile = db.Profiles(ProfileID)

set db = Viewer.OpenDatabase(DatabasePath)

dim oFile
set fso = createobject("Scripting.FileSystemObject")
set shell = createObject("WScript.Shell")

randomize

'Get random profile
set oFile = fso.CreateTextFile("RandomProfileTest.txt", true, true)
set Profiles = db.Profiles
if Profiles.Count <> 0 then
	set Profile = Profiles(cint(rnd * profiles.Count))
	GetProfileInfos Profile
end if
oFile.Close
shell.run "notepad.exe RandomProfileTest.txt"

'Get Random Series
set oFile = fso.CreateTextFile("RandomSeriesTest.txt", true, true)
set TVShows = db.TVShows
if TVShows.Count <> 0 then
	set Series = TVShows(cint(rnd * TVShows.count))
	GetSeriesInfos Series
end if
oFile.Close
shell.run "notepad.exe RandomSeriesTest.txt"

set oFile = fso.CreateTextFile("AdditionalTests.txt", true, true)

'Find Appearances
SearchFor = "Tom Hanks"
Text = ""
set Appearances = db.FindAppearances(SearchFor, true, true, false, true, false)  'Name, [IncludeProfiles=true, IncludeEpisodes=true, OnlyIncludeAssignedEpisodes=false, IncludeCast=true, IncludeCrew=true]
for each Appearance in Appearances
	select case TypeName(Appearance)
		case "CCVProfile":
			text = text & Appearance.Title & vbcrlf
		case "CCVEpisode":
			text = text & db.TVShows(Appearance.ShowID).Title & ": " & Appearance.Season & " - " & Appearance.Title & vbcrlf
	end select
next
WriteInfo Text, "Appearances for " & SearchFor

'Find Awards
SearchForMovie = "Titanic"
SearchForYear = 1997
Text = ""
set Awards = db.GetMovieAwards(SearchForMovie, SearchForYear) 
for each Award in Awards
	Text = text & "Award: " & Award.Award & vbcrlf 
	Text = text & "Category: " & Award.Category & vbcrlf 
	Text = text & "Has Won: " & Award.HasWon & vbcrlf 
	Text = text & "Nominees: " & vbcrlf
	set Nominees = Viewer.SplitUpNominees(Award.Nominee)
	for i = 1 to Nominees.Count
		text = text & vbtab & Nominees(i)  & vbcrlf
	next
	text = text & vbcrlf
next
WriteInfo Text, "Awards for " & SearchForMovie
oFile.Close
shell.run "notepad.exe AdditionalTests.txt"


sub GetProfileInfos(byref Profile)
	text = text & "ProfileID: " & profile.ProfileID & vbcrlf
	text = text & "Medium: " & profile.Medium & vbcrlf
	text = text & "Title: " & profile.Title & vbcrlf
	text = text & "Original Title: " & profile.OriginalTitle & vbcrlf
	text = text & "Sort Title: " & profile.SortTitle & vbcrlf
	text = text & "Original Sort Title: " & profile.OriginalSortTitle & vbcrlf
	text = text & "Description: " & profile.Description & vbcrlf
	text = text & "Collection Number: " & profile.CollectionNumber & vbcrlf
	text = text & "Collection Type: " & profile.CollectionType & vbcrlf
	text = text & "UPC: " & profile.UPC & vbcrlf
	text = text & "Timestamp: " & profile.ProfileTimeStamp & vbcrlf
	text = text & "Rating: " & profile.Rating & vbcrlf
	text = text & "RatingSystem: " & profile.RatingSystem & vbcrlf
	text = text & "RatingDetails: " & profile.RatingDetails & vbcrlf
	text = text & "Production Year: " & profile.ProductionYear & vbcrlf
	text = text & "Release Date: " & profile.ReleaseDate & vbcrlf
	text = text & "Running Time: " & profile.RunningTime & vbcrlf
	text = text & "Case Type: " & profile.CaseType & vbcrlf
	text = text & "Last Edited: " & profile.LastEdited & vbcrlf
	text = text & "Wishlist Priority: " & profile.WishListPriority & vbcrlf
	text = text & "Data Source: " & profile.DataSource & vbcrlf
	text = text & "Locality: " & profile.Locality & vbcrlf
	text = text & "Country of Origin: " & profile.CountryOfOrigin & vbcrlf
	WriteInfo text, "Profile"

	WriteInfo profile.Overview, "Overview"
	WriteInfo profile.Notes, "Notes"
	WriteInfo profile.EasterEggs, "EasterEggs"

	text = ""
	'Get Awards
	for each Award in Profile.Awards
		Text = text & "Award: " & Award.Award & vbcrlf 
		Text = text & "Category: " & Award.Category & vbcrlf 
		Text = text & "Has Won: " & Award.HasWon & vbcrlf 
		Text = text & "Nominees: " & vbcrlf
		set Nominees = Viewer.SplitUpNominees(Award.Nominee)
		for i = 1 to Nominees.Count
			text = text & vbtab & Nominees(i)  & vbcrlf
		next
		text = text & vbcrlf
	next
	WriteInfo Text, "Award"


	'Get Studios
	Text = ""
	for each Studio in Profile.Studios
		Text = Text & Studio.Name & vbtab & Studio.StudioType & vbcrlf
	next
	WriteInfo Text, "Studios"

	'Get Features
	Text = ""
	for each Feature in Profile.Features
		Text = Text & Feature & vbcrlf
	next
	WriteInfo Text, "Features"

	'Get AudioFormats
	Text = ""
	for each AudioFormat in Profile.Audio
		Text = Text & AudioFormat.Position & vbtab & AudioFormat.Language & vbtab & AudioFormat.Compression & vbtab & AudioFormat.Channels & vbcrlf
	next
	WriteInfo Text, "Audio Formats"

	'Get Genres
	Text = ""
	for each Genre in Profile.Genres
		Text = Text & Genre & vbcrlf
	next
	WriteInfo Text, "Genres"

	'Get Locks
	Text = ""
	for each Lock in Profile.Locks
		Text = Text & Lock & vbcrlf
	next
	WriteInfo Text, "Locks"

	'Get Events
	Text = ""
	for each sEvent in Profile.Events
		Text = Text & "EventID: " & sEvent.EventID & vbcrlf
		Text = Text & "TimeStamp: " & sEvent.TimeStamp & vbcrlf
		Text = Text & "Type: " & sEvent.EventType & vbcrlf
		Text = Text & "User: " & vbcrlf
		Text = Text & "  Name: " & sEvent.User.Name & vbcrlf
	    Text = Text & "  Phone: " & sEvent.User.Phone  & vbcrlf
	    Text = Text & "  Email: " & sEvent.User.Email & vbcrlf & vbcrlf
	next
	WriteInfo Text, "Events"

	'Get Loan Info
	Text = ""
	set LoanInfo = Profile.LoanInfo
  if not LoanInfo Is Nothing then
  	Text = Text & "Loaned Due: " & LoanInfo.LoanedDue & vbcrlf
  	Text = Text & "User: " & vbcrlf
  	Text = Text & "  Name: " & LoanInfo.User.Name & vbcrlf
  	Text = Text & "  Phone: " & LoanInfo.User.Phone  & vbcrlf
  	Text = Text & "  Email: " & LoanInfo.User.Email & vbcrlf & vbcrlf
  	WriteInfo Text, "Loan Info"
  end if

	'Get Purchase Info
	Text = ""
	set PurchaseInfo = Profile.PurchaseInfo
	Text = Text & "Price: " & PurchaseInfo.Price & vbcrlf
	Text = Text & "CurrencyID: " & PurchaseInfo.CurrencyID & vbcrlf
	Text = Text & "Currency Symbol: " & PurchaseInfo.GetCurrency.CurrencySymbol & vbcrlf
	Text = Text & "Currency Name: " & PurchaseInfo.GetCurrency.CurrencyName & vbcrlf
	Text = Text & "Puchase Place: " & vbcrlf
	Text = Text & "  Name: " & PurchaseInfo.PurchasePlace.Name & vbcrlf
	Text = Text & "  Place Type: " & PurchaseInfo.PurchasePlace.PlaceType  & vbcrlf
	Text = Text & "  Website: " & PurchaseInfo.PurchasePlace.Website & vbcrlf & vbcrlf
	WriteInfo Text, "Purchase Info"

	'Get SRP
	Text = ""
	set SRP = Profile.SRP
	Text = Text & "Value: " & SRP.Value & vbcrlf
	Text = Text & "CurrencyID: " & SRP.CurrencyID & vbcrlf
	Text = Text & "Currency Symbol: " & SRP.GetCurrency.CurrencySymbol & vbcrlf
	Text = Text & "Currency Name: " & SRP.GetCurrency.CurrencyName & vbcrlf
	WriteInfo Text, "SRP"

	'Get Review
	Text = ""
	set Review = Profile.Review
	Text = Text & "Film: " & Review.Film & vbcrlf
	Text = Text & "Video: " & Review.Video & vbcrlf
	Text = Text & "Audio: " & Review.Audio & vbcrlf
	Text = Text & "Extras: " & Review.Extras & vbcrlf
	WriteInfo Text, "Review"

	'Get VideoFormats
	Text = ""
	set VideoFormat = Profile.Video
	Text = Text & "Aspect Ratio: " & VideoFormat.AspectRatio & vbcrlf
	Text = Text & "Standard: " & VideoFormat.VideoStandard & vbcrlf
	text = text & "Letterbox: " & VideoFormat.LetterBox & vbcrlf
	text = text & "Pan & Scan: " & VideoFormat.PanAndScan & vbcrlf
	text = text & "Full Frame: " & VideoFormat.FullFrame & vbcrlf
	text = text & "Anamorphic: " & VideoFormat.Anamorphic & vbcrlf & vbcrlf
	WriteInfo Text, "Video Formats"

	'Get additional Infos
	for each Info in Profile.Infos
		WriteInfo Info.Value, Info.Name
	next
	
	'Get Tags for Profile
	Text = ""
	for each tag in Profile.Tags
		Text = Text & Tag.Name & " / " &  Tag.LongName & vbcrlf
	next
	WriteInfo Text, "Tags"	
		
	'Get assigned episodes for profile
	Text = ""
	for each Episode in Profile.Episodes
		Text = Text & Episode.Number & " - " & Episode.Title & vbcrlf
	next
	WriteInfo Text, "Episodes"

	'Get Cast for Profile
	Text = ""
	for each Credit in Profile.Cast
		CreditedAs = Credit.Name
		CommonName = Credit.CommonName
		Text = Text & CommonName
		if CreditedAs <> CommonName then Text = Text & "(as " & CreditedAs & ")"
		Text = Text & " - " & Credit.Role & " (" & Credit.BirthYear & ")" 
    if Credit.IsVoice then Text = Text & " (voice)"
    if Credit.IsUncredited then Text = Text & " (uncredited)"
    Text = Text & vbcrlf
	next
	WriteInfo Text, "Cast"

	'Get Crew for Profile
	Text = ""
	for each Credit in Profile.Crew
		CreditedAs = Credit.Name
		CommonName = Credit.CommonName
		Text = Text & CommonName
		if CreditedAs <> CommonName then Text = Text & "(as " & CreditedAs & ")"
		Text = Text & " - " & Credit.Role & " (" & Credit.BirthYear & ")" &  vbcrlf
	next
	WriteInfo Text, "Crew"
	
	WriteInfo "", "Episodes"
	for each Episode in Profile.Episodes
		GetEpisodeInfos Episode
	next
	
	for each ChildProfile in Profile.ChildProfiles
		WriteInfo "", "Child Profile " & ChildProfile.Title
		GetProfileInfos ChildProfile
	next
	



end sub




sub GetEpisodeInfos(byref Episode)
	text = text & "EpisodeID: " & Episode.EpisodeID & vbcrlf
	text = text & "ShowID: " & Episode.ShowID & vbcrlf
	text = text & "Season: " & Episode.Season & vbcrlf
	text = text & "Episode Number: " & Episode.Number & vbcrlf
	text = text & "Title: " & Episode.Title & vbcrlf
	text = text & "Original Title: " & Episode.OriginalTitle & vbcrlf
	text = text & "Rating: " & Episode.Rating & vbcrlf
	text = text & "Airdate: " & Episode.Airdate & vbcrlf
	text = text & "Running Time: " & Episode.RunningTime & vbcrlf
	WriteInfo text, "Episode"

	WriteInfo Episode.Overview, "Overview"
	WriteInfo Episode.Notes, "Notes"

	text = ""
	'Get Awards
	for each Award in Episode.Awards
		Text = text & "Award: " & Award.Award & vbcrlf 
		Text = text & "Category: " & Award.Category & vbcrlf 
		Text = text & "Has Won: " & Award.HasWon & vbcrlf 
		Text = text & "Nominees: " & vbcrlf
		set Nominees = Viewer.SplitUpNominees(Award.Nominee)
		for i = 1 to Nominees.Count
			text = text & vbtab & Nominees(i)  & vbcrlf
		next
		text = text & vbcrlf
	next
	WriteInfo Text, "Award"


	'Get Studios
	Text = ""
	for each Studio in Episode.Studios
		Text = Text & Studio.name & vbtab & Studio.studiotype & vbcrlf
	next
	WriteInfo Text, "Studios"

	'Get Features
	Text = ""
	for each Feature in Episode.Features
		Text = Text & Feature & vbcrlf
	next
	WriteInfo Text, "Features"

	'Get AudioFormats
	Text = ""
	for each AudioFormat in Episode.Audio
		Text = Text & AudioFormat.Position & vbtab & AudioFormat.Language & vbtab & AudioFormat.Compression & vbtab & AudioFormat.Channels & vbcrlf
	next
	WriteInfo Text, "Audio Formats"

	'Get Genres
	Text = ""
	for each Genre in Episode.Genres
		Text = Text & Genre & vbcrlf
	next
	WriteInfo Text, "Genres"

	'Get Locks
	Text = ""
	for each Lock in Episode.Locks
		Text = Text & Lock & vbcrlf
	next
	WriteInfo Text, "Locks"

	'Get Events
	Text = ""
	for each sEvent in Episode.Events
		Text = Text & "EventID: " & sEvent.EventID & vbcrlf
		Text = Text & "TimeStamp: " & sEvent.TimeStamp & vbcrlf
		Text = Text & "Type: " & sEvent.EventType & vbcrlf
		Text = Text & "User: " & vbcrlf
		Text = Text & "  Name: " & sEvent.User.Name & vbcrlf
	    Text = Text & "  Phone: " & sEvent.User.Phone  & vbcrlf
	    Text = Text & "  Email: " & sEvent.User.Email & vbcrlf & vbcrlf
	next
	WriteInfo Text, "Events"

	
	'Get Review
	Text = ""
	set Review = Episode.Review
	Text = Text & "Film: " & Review.Film & vbcrlf
	Text = Text & "Video: " & Review.Video & vbcrlf
	Text = Text & "Audio: " & Review.Audio & vbcrlf
	Text = Text & "Extras: " & Review.Extras & vbcrlf
	WriteInfo Text, "Review"

	'Get VideoFormats
	Text = ""
	set VideoFormat = Episode.Video
	Text = Text & "Aspect Ratio: " & VideoFormat.AspectRatio & vbcrlf
	Text = Text & "Standard: " & VideoFormat.VideoStandard & vbcrlf
	text = text & "Letterbox: " & VideoFormat.LetterBox & vbcrlf
	text = text & "Pan & Scan: " & VideoFormat.PanAndScan & vbcrlf
	text = text & "Full Frame: " & VideoFormat.FullFrame & vbcrlf
	text = text & "Anamorphic: " & VideoFormat.Anamorphic & vbcrlf & vbcrlf
	WriteInfo Text, "Video Formats"

	'Get additional Infos
	for each Info in Episode.Infos
		WriteInfo Info.Value, Info.Name
	next
		

	'Get Cast for Profile
	Text = ""
	for each Credit in Episode.Cast
		CreditedAs = Credit.Name
		CommonName = Credit.CommonName
		Text = Text & CommonName
		if CreditedAs <> CommonName then Text = Text & "(as " & CreditedAs & ")"
		Text = Text & " - " & Credit.Role & vbcrlf
	next
	WriteInfo Text, "Cast"

	'Get Crew for Profile
	Text = ""
	for each Credit in Episode.Crew
		CreditedAs = Credit.Name
		CommonName = Credit.CommonName
		Text = Text & CommonName
		if CreditedAs <> CommonName then Text = Text & "(as " & CreditedAs & ")"
		Text = Text & " - " & Credit.Role & vbcrlf
	next
	WriteInfo Text, "Crew"


end sub


sub GetSeriesInfos(byref Series)
	text = text & "ShowID: " & Series.ShowID & vbcrlf
	text = text & "Title: " & Series.Title & vbcrlf
	text = text & "Original Title: " & Series.OriginalTitle & vbcrlf
	text = text & "Sort Title: " & Series.SortTitle & vbcrlf
	WriteInfo text, "Series"
	
	text = ""
	'Get Awards
	for each Award in Series.Awards
		Text = text & "Award: " & Award.Award & vbcrlf 
		Text = text & "Category: " & Award.Category & vbcrlf 
		Text = text & "Has Won: " & Award.HasWon & vbcrlf 
		Text = text & "Nominees: " & vbcrlf
		set Nominees = Viewer.SplitUpNominees(Award.Nominee)
		for i = 1 to Nominees.Count
			text = text & vbtab & Nominees(i)  & vbcrlf
		next
		text = text & vbcrlf
	next
	WriteInfo Text, "Award"

	'Get Locks
	Text = ""
	for each Lock in Series.Locks
		Text = Text & Lock & vbcrlf
	next
	WriteInfo Text, "Locks"
	
	for each Season in Series.Seasons
		WriteInfo "", Season.Name
		
		'Get Locks
		Text = ""
		for each Lock in Season.Locks
			Text = Text & Lock & vbcrlf
		next
		WriteInfo Text, "Locks"
		
		for each Episode in Season.Episodes
			GetEpisodeInfos Episode
		next
	next

end sub




'************************************************

sub WriteInfo(byval Info, Header)
	ofile.Writeline vbcrlf & "---------------------------"
	ofile.Writeline Header
	ofile.Writeline "---------------------------"
	ofile.WriteLine Info

end sub
	
