'Copyright 2007 TomGaines
'This script shows an example of the writing functions from the CCVControl.dll
'It will generate a new database from data included in a CCVViewer collection file (v1.5.2 or higher Export file needed)


set Viewer = CreateObject("CCVCtrl.Control")
randomize
set db = Viewer.CreateDatabase("TestWriting_" & Int(rnd*10000000))
set shell = createObject("WScript.Shell")

Value = CCur("1.23")
if Value = 123 then
  DecimalSeparator = ","
else 
  DecimalSeparator = "."
end if

'CollectionFile = "D:\Apps\Workspaces\CastCrewViewer\CCViewer\CCVCollection.xml"
if CollectionFile <> "" then CollectionFile = InputBox("Enter filepath to the Viewer collection file", "Viewer Collection File", "CCVCollection.xml")
if CollectionFile <> "" then 
	dim fso: set fso = CreateObject("Scripting.FileSystemObject")
	if not fso.FileExists(CollectionFile) then 
		MsgBox "Incorrect File Path", vbokonly + vbexclamation, "Incorrect File Path"
	else:
		ImportData CollectionFile
    msgbox "Finished"
	end if
end if

sub ImportData(CollectionFile)
	Set XMLData = CreateObject("msxml2.DOMDocument.3.0")
	XMLData.load CollectionFile

	set CollectionData = XMLData.SelectSingleNode("CCVCollection")
	if CollectionData is Nothing then 
		msgbox "Invalid collection file!" + vbcrlf + _
				cstr(XMLData.ParseError.reason) + "Line " + cstr(XMLData.ParseError.line), _
				vbokonly + vbexclamation, "Invalid XML"
		exit sub
	end if

 
  for each DVDNode in CollectionData.SelectNodes("Profile")
    set Profile = CreateObject("CCVCtrl.CCVProfile")
    Profile.ProfileID = WriteNodeToDb(DVDNode.SelectSingleNode("ProfileID"), Profile.ProfileID)
    Profile.Medium = WriteNodeToDb(DVDNode.SelectSingleNode("Medium"), Profile.Medium)
    Profile.Title = WriteNodeToDb(DVDNode.SelectSingleNode("Title"), Profile.Title)
    Profile.SortTitle = WriteNodeToDb(DVDNode.SelectSingleNode("SortTitle"), Profile.SortTitle)
    Profile.Description = WriteNodeToDb(DVDNode.SelectSingleNode("Description"), Profile.Description)
    Profile.OriginalTitle = WriteNodeToDb(DVDNode.SelectSingleNode("OriginalTitle"), Profile.OriginalTitle)
    Profile.OriginalSortTitle = WriteNodeToDb(DVDNode.SelectSingleNode("OriginalSortTitle"), Profile.OriginalSortTitle)
    Profile.CollectionNumber = WriteNodeToDb(DVDNode.SelectSingleNode("CollectionNumber"), Profile.CollectionNumber)
    Profile.CollectionType = WriteNodeToDb(DVDNode.SelectSingleNode("CollectionType"), Profile.CollectionType)
    Profile.UPC = WriteNodeToDb(DVDNode.SelectSingleNode("UPC"), Profile.UPC)
    Profile.ProfileTimestamp = WriteNodeToDb(DVDNode.SelectSingleNode("ProfileTimestamp"), Profile.ProfileTimestamp)
    Profile.Rating = WriteNodeToDb(DVDNode.SelectSingleNode("Rating"), Profile.Rating)
    Profile.RatingSystem = WriteNodeToDb(DVDNode.SelectSingleNode("RatingSystem"), Profile.RatingSystem)
    Profile.RatingDetails = WriteNodeToDb(DVDNode.SelectSingleNode("RatingDetails"), Profile.RatingDetails)
    Profile.ProductionYear = WriteNodeToDb(DVDNode.SelectSingleNode("ProductionYear"), Profile.ProductionYear)
    Profile.ReleaseDate = WriteNodeToDb(DVDNode.SelectSingleNode("ReleaseDate"), Profile.ReleaseDate)
    Profile.RunningTime = WriteNodeToDb(DVDNode.SelectSingleNode("RunningTime"), Profile.RunningTime)
    Profile.CaseType = WriteNodeToDb(DVDNode.SelectSingleNode("CaseType"), Profile.CaseType)
    Profile.Overview = WriteNodeToDb(DVDNode.SelectSingleNode("Overview"), Profile.Overview)
    Profile.LastEdited = WriteNodeToDb(DVDNode.SelectSingleNode("LastEdited"), Profile.LastEdited)
    Profile.WishListPriority = WriteNodeToDb(DVDNode.SelectSingleNode("WishListPriority"), Profile.WishListPriority)
    Profile.DataSource = WriteNodeToDb(DVDNode.SelectSingleNode("DataSource"), Profile.DataSource)
    Profile.Locality = WriteNodeToDb(DVDNode.SelectSingleNode("Locality"), Profile.Locality)
    Profile.Notes = WriteNodeToDb(DVDNode.SelectSingleNode("Notes"), Profile.Notes)
    Profile.EasterEggs = WriteNodeToDb(DVDNode.SelectSingleNode("EasterEggs"), Profile.EasterEggs)
    Profile.CountryOfOrigin = WriteNodeToDb(DVDNode.SelectSingleNode("CountryOfOrigin"), Profile.CountryOfOrigin)
    Profile.CountAs = WriteNodeToDb(DVDNode.SelectSingleNode("CountAs"), Profile.CountAs)
    
    GetCollection DVDNode.SelectSingleNode("Genres"), Profile.Genres
    GetCollection DVDNode.SelectSingleNode("Regions"), Profile.Regions
    GetCollection DVDNode.SelectSingleNode("Features"), Profile.Features
    GetCollection DVDNode.SelectSingleNode("Subtitles"), Profile.Subtitles
    GetCollection DVDNode.SelectSingleNode("Locks"), Profile.Locks
    
    with Profile.Discs
      Set ParentNode = DVDNode.SelectSingleNode("Discs")
      if not ParentNode Is Nothing then
        for each node in ParentNode.SelectNodes("Disc")
          set Disc = CreateObject("CCVCtrl.CCVDisc")
          Disc.Number = WriteNodeToDb(node.SelectSingleNode("DiscNumber"), Disc.Number)
          Disc.Description = WriteNodeToDb(node.SelectSingleNode("Description"), Disc.DescriptionSideA) 
          Disc.Description = WriteNodeToDb(node.SelectSingleNode("DescriptionSideB"), Disc.DescriptionSideB)
          Disc.DiscIDSideA = WriteNodeToDb(node.SelectSingleNode("DiscIDSideA"), Disc.DiscIDSideA)
          Disc.DiscIDSideB = WriteNodeToDb(node.SelectSingleNode("DiscIDSideB"), Disc.DiscIDSideB)
          Disc.LabelSideA = WriteNodeToDb(node.SelectSingleNode("LabelSideA"), Disc.LabelSideA)
          Disc.LabelSideB = WriteNodeToDb(node.SelectSingleNode("LabelSideB"), Disc.LabelSideB)
          Disc.DualSided = WriteNodeToDb(node.SelectSingleNode("DualSided"), Disc.DualSided)
          Disc.DualLayered = WriteNodeToDb(node.SelectSingleNode("DualLayered"), Disc.DualLayered)
          Disc.Flipper = WriteNodeToDb(node.SelectSingleNode("Flipper"), Disc.Flipper)
          Disc.Location = WriteNodeToDb(node.SelectSingleNode("Location"), Disc.Location)
          Disc.Slot = WriteNodeToDb(node.SelectSingleNode("Slot"), Disc.Slot)
          .addDisc Disc
        next
      end if
    end with
    
    GetProfileEpisodeInfos Profile, DVDNode
    
    
    set Node = DVDNode.SelectSingleNode("SRPInfo")
    if not Node is Nothing then
      with Profile.SRP
        CurrencyID = WriteNodeToDb(Node.SelectSingleNode("CurrencyID"), "")
        if not db.Currencies.Exists(CurrencyID) then 
          db.Currencies.Add cstr(CurrencyID), _
                      cstr(WriteNodeToDb(Node.SelectSingleNode("CurrencyName"), "")), _
                      cstr(WriteNodeToDb(Node.SelectSingleNode("CurrencySymbol"), ""))
        end if
        .Value = WriteNodeToDb(Node.SelectSingleNode("SRPValue"), .Value)
        .CurrencyID = CurrencyID
      end with
    end if

        
    set Node = DVDNode.SelectSingleNode("PurchaseInfo")
    if not Node is Nothing then
      with Profile.PurchaseInfo
        CurrencyID = WriteNodeToDb(Node.SelectSingleNode("CurrencyID"), "")
        if not db.Currencies.Exists(CurrencyID) then 
          db.Currencies.Add cstr(CurrencyID), _
                      cstr(WriteNodeToDb(Node.SelectSingleNode("CurrencyName"), "")), _
                      cstr(WriteNodeToDb(Node.SelectSingleNode("CurrencySymbol"), ""))
        end if
        PurchasePlace = WriteNodeToDb(Node.SelectSingleNode("PurchasePlace").SelectSingleNode("RetailerName"), "")
        if not db.Retailers.Exists(PurchasePlace) then 
          db.Retailers.Add cstr(PurchasePlace), _
                      cstr(WriteNodeToDb(Node.SelectSingleNode("PurchasePlace").SelectSingleNode("RetailerType"), "")), _
                      cstr(WriteNodeToDb(Node.SelectSingleNode("PurchasePlace").SelectSingleNode("Website"), ""))
        end if
        .Price = WriteNodeToDb(Node.SelectSingleNode("Price"), .Price)
        .CurrencyID = CurrencyID
        .PurchaseDate = WriteNodeToDb(Node.SelectSingleNode("PurchaseDate"), .PurchaseDate)
        .PurchasePlaceName = PurchasePlace
      end with
    end if
    

    REM Currently not supported
    REM Set ParentNode = DVDNode.SelectSingleNode("Awards")
    REM if not ParentNode is Nothing then    
      REM for each Node in ParentNode.SelectNodes("Award")
        REM set Award = CreateObject("CCVCtrl.CCVAward")
        REM Award.Award = WriteNodeToDb(Node.SelectSingleNode("AwardName"), Award.Award)
        REM Award.Year = WriteNodeToDb(Node.SelectSingleNode("Year"), Award.Year)
        REM Award.Category = WriteNodeToDb(Node.SelectSingleNode("Category"), Award.Category)
        REM Award.HasWon = WriteNodeToDb(Node.SelectSingleNode("Won"), Award.HasWon)
        REM Award.Nominee = WriteNodeToDb(Node.SelectSingleNode("Nominee"), Award.Nominee)
        REM Title = Profile.OriginalTitle
        REM if Title = "" then Title = Profile.Title
        REM Award.MovieTitle = Title
        REM db.Awards.AddAward Award
      REM next
    REM end if    

    
    set Node = DVDNode.SelectSingleNode("LoanInfo")
    if not Node is Nothing then
      with Profile.LoanInfo
        User = WriteNodeToDb(Node.SelectSingleNode("User"), "")
        if not db.Users.Exists(User) then db.Users.Add cstr(User)
        .UserID = User
        .LoanedDue = WriteNodeToDb(Node.SelectSingleNode("LoanedDue"), .LoanedDue)
      end with
    end if
    
    set node = DVDNode.SelectSingleNode("BoxSet")
    if not node Is Nothing then 
      for each childnode in node.SelectNodes("ChildID")
        profile.AssignBoxsetChild childnode.Text
      next
    end if
    
    set EpisodesNode = DVDNode.SelectSingleNode("Episodes")
    if not EpisodesNode is Nothing then
      for each EpisodeNode in EpisodesNode.SelectNodes("Episode")
        profile.AssignEpisode EpisodeNode.SelectSingleNode("EpisodeID").Text
        SeriesID = EpisodeNode.SelectSingleNode("SeriesID").Text
        if not db.TVShows.Exists(SeriesID) then
          set TVShow = db.TVShows.add(cstr(WriteNodeToDb(EpisodeNode.SelectSingleNode("SeriesID"), "")), _
                      cstr(WriteNodeToDb(EpisodeNode.SelectSingleNode("SeriesTitle"), "")), _
                      cstr(WriteNodeToDb(EpisodeNode.SelectSingleNode("SeriesSortTitle"), "")), _
                      cstr(WriteNodeToDb(EpisodeNode.SelectSingleNode("SeriesOriginalTitle"), "")), _
                      cstr(WriteNodeToDb(EpisodeNode.SelectSingleNode("SeriesOriginalSortTitle"), "")))
        else
          set TVShow = db.TVShows(SeriesID)
        end if
        SeasonName = EpisodeNode.SelectSingleNode("Season").Text
        if not TVShow.Seasons.Exists(SeasonName) then
          set Season = TVShow.Seasons.add(SeasonName)
        else
          set Season = TVShow.Seasons(SeasonName)
        end if
        set Episodes = Season.Episodes
        set Episode = CreateObject("CCVCtrl.CCVEpisode")
        EpisodeID = WriteNodeToDb(EpisodeNode.SelectSingleNode("EpisodeID"), Episode.EpisodeID)
        if not Episodes.Exists(EpisodeID) then
          Episode.EpisodeID = EpisodeID
          Episode.Number = WriteNodeToDb(EpisodeNode.SelectSingleNode("EpisodeNumber"), Episode.Number)
          Episode.Title = WriteNodeToDb(EpisodeNode.SelectSingleNode("Title"), Episode.Title)
          Episode.OriginalTitle = WriteNodeToDb(EpisodeNode.SelectSingleNode("OriginalTitle"), Episode.OriginalTitle)
          Episode.Overview = WriteNodeToDb(EpisodeNode.SelectSingleNode("Overview"), Episode.Overview)
          Episode.Notes = WriteNodeToDb(EpisodeNode.SelectSingleNode("Notes"), Episode.Notes)
          Episode.Runningtime = WriteNodeToDb(EpisodeNode.SelectSingleNode("Runtime"), Episode.Runningtime)
          Episode.Rating = WriteNodeToDb(EpisodeNode.SelectSingleNode("Rating"), Episode.Rating)
          Episode.Airdate = WriteNodeToDb(EpisodeNode.SelectSingleNode("Airdate"), Episode.Airdate)
          
          GetCollection EpisodeNode.SelectSingleNode("Locks"), Episode.Locks
          GetCollection EpisodeNode.SelectSingleNode("Genres"), Episode.Genres
          GetCollection EpisodeNode.SelectSingleNode("Features"), Episode.Features
          GetCollection EpisodeNode.SelectSingleNode("Subtitles"), Episode.Subtitles        
          
          GetProfileEpisodeInfos Episode, EpisodeNode
          Episodes.AddEpisode Episode
        end if
      next
    end if
    
    call db.Profiles.AddProfile(Profile)
  next
  
  
  
  
  Viewer.CloseDatabase
  set viewer = Nothing
  msgbox "Finished"
end sub



sub GetCollection(ParentNode, byref Collection)
  if ParentNode is Nothing then exit sub
  for each node in ParentNode.ChildNodes
    Collection.add WriteNodeToDb(Node, "")
  next
end sub



sub GetProfileEpisodeInfos(CCVObject, XMLNode)

    set Node = XMLNode.SelectSingleNode("VideoFormat")
    if not Node is Nothing then
      with CCVObject.Video
        .AspectRatio = WriteNodeToDb(Node.SelectSingleNode("AspectRatio"), .AspectRatio)
        .VideoStandard = WriteNodeToDb(Node.SelectSingleNode("VideoStandard"), .VideoStandard)
        .LetterBox = WriteNodeToDb(Node.SelectSingleNode("LetterBox"), .LetterBox)
        .PanAndScan = WriteNodeToDb(Node.SelectSingleNode("PanAndScan"), .PanAndScan)
        .FullFrame = WriteNodeToDb(Node.SelectSingleNode("FullFrame"), .FullFrame)
        .Anamorphic = WriteNodeToDb(Node.SelectSingleNode("Anamorphic"), .Anamorphic)
      end with
    end if
   
    Set ParentNode = XMLNode.SelectSingleNode("Studios")
    if not ParentNode is Nothing then
      for each Node in ParentNode.SelectNodes("Studio")
        CCVObject.Studios.Add WriteNodeToDb(Node.SelectSingleNode("Name"), ""), WriteNodeToDb(Node.SelectSingleNode("Type"), "")
      next
    end if    


    
    i = 1
    Set ParentNode = XMLNode.SelectSingleNode("Cast")
    if not ParentNode is Nothing then    
      for each Node in ParentNode.SelectNodes("CastMember")
        set Credit = CreateObject("CCVCtrl.CCVCredit")
        Credit.Name = WriteNodeToDb(Node.SelectSingleNode("Name"), Credit.Name)
        Credit.Role = WriteNodeToDb(Node.SelectSingleNode("Role"), Credit.Role)
        Credit.IsUncredited = WriteNodeToDb(Node.SelectSingleNode("IsUncredited"), Credit.IsUncredited)
        Credit.IsVoice = WriteNodeToDb(Node.SelectSingleNode("IsVoice"), Credit.IsVoice)
        Credit.BirthYear = WriteNodeToDb(Node.SelectSingleNode("BirthYear"), Credit.BirthYear)
        Credit.Position = i
        CCVObject.Cast.AddCredit Credit
        i = i + 1
      next
    end if
  
    i = 1
    Set ParentNode = XMLNode.SelectSingleNode("Crew")
    if not ParentNode is Nothing then      
      for each Node in ParentNode.SelectNodes("CrewMember")
        CCVObject.Crew.Add WriteNodeToDb(Node.SelectSingleNode("Name"), ""), WriteNodeToDb(Node.SelectSingleNode("Role"), ""), CInt(i), CInt(WriteNodeToDb(Node.SelectSingleNode("BirthYear"), 0))
        i = i + 1
      next    
    end if
    
    Set ParentNode = XMLNode.SelectSingleNode("AudioFormats")
    if not ParentNode is Nothing then    
      for each Node in ParentNode.SelectNodes("AudioFormat")
        set AudioFormat = CreateObject("CCVCtrl.CCVAudioFormat")
        AudioFormat.Position = WriteNodeToDb(Node.SelectSingleNode("TrackNumber"), AudioFormat.Position)
        AudioFormat.Language = WriteNodeToDb(Node.SelectSingleNode("Language"), AudioFormat.Language)
        AudioFormat.Compression = WriteNodeToDb(Node.SelectSingleNode("Compression"), AudioFormat.Compression)
        AudioFormat.Channels = WriteNodeToDb(Node.SelectSingleNode("Channels"), AudioFormat.Channels)
        CCVObject.Audio.AddAudioFormat AudioFormat
      next
    end if
    
    set Node = XMLNode.SelectSingleNode("Review")
    if not Node is Nothing then
      with CCVObject.Review
        .Film = WriteNodeToDb(Node.SelectSingleNode("Film"), .Film)
        .Video = WriteNodeToDb(Node.SelectSingleNode("Video"), .Video)
        .Audio = WriteNodeToDb(Node.SelectSingleNode("Audio"), .Audio)
        .Extras = WriteNodeToDb(Node.SelectSingleNode("Extras"), .Extras)
      end with    
    end if
    
    
    Set ParentNode = XMLNode.SelectSingleNode("Tags")
    if not ParentNode is Nothing then    
      for each Node in ParentNode.SelectNodes("Tag")
        set Tag = CreateObject("CCVCtrl.CCVTag")
        Tag.Name = WriteNodeToDb(Node.SelectSingleNode("TagName"), Tag.Name)
        Tag.LongName = WriteNodeToDb(Node.SelectSingleNode("FullyQualifiedName"), Tag.LongName)
        CCVObject.Tags.AddTag Tag
      next
    end if
    
    Set ParentNode = XMLNode.SelectSingleNode("AdditionalInfos")
    if not ParentNode is Nothing then    
      for each Node in ParentNode.SelectNodes("Info")
        set Info = CreateObject("CCVCtrl.CCVInfo")
        Info.Name = WriteNodeToDb(Node.SelectSingleNode("InfoName"), Info.Name)
        Info.Value = WriteNodeToDb(Node.SelectSingleNode("InfoValue"), Info.Value)
        CCVObject.Infos.AddInfo Info
      next
    end if
    
    
    Set ParentNode = XMLNode.SelectSingleNode("Events")
    if not ParentNode is Nothing then
      for each Node in ParentNode.SelectNodes("Event")
        set cEvent = CreateObject("CCVCtrl.CCVEvent")
        User = WriteNodeToDb(Node.SelectSingleNode("User"), "")
        if not db.Users.Exists(User) then db.Users.add User
        cEvent.UserID = User
        cEvent.EventType = WriteNodeToDb(Node.SelectSingleNode("EventType"), cEvent.EventType)
        cEvent.TimeStamp = WriteNodeToDb(Node.SelectSingleNode("TimeStamp"), cEvent.TimeStamp)
        CCVObject.Events.AddEvent cEvent
      next
    end if

end sub


Function WriteNodeToDb(Node, WriteTo)
  if not Node is Nothing then
    Value = Node.Text
  else
    Value = ""
  end if

  select case TypeName(WriteTo)
    case "String": 
      WriteNodeToDb = CStr(Replace(Value, vblf, vbcrlf))
    case "Integer": 
      if Value = "" then Value = 0
      WriteNodeToDb = CInt(Value)
    case "Long": 
      if Value = "" then Value = 0
      WriteNodeToDb = CLng(Value)
    case "Date": 
      if Value = "" then Value = "1899-12-30"
      WriteNodeToDb = CDate(Value)
    case "Boolean":
      if Value = "" then Value = "False"
      if lcase(Value) = "x" then Value = True
      WriteNodeToDb = CBool(Value)
    case "Currency":
      if Value = "" then Value = "0.00"
      NewValue = CCur(Value)
      WriteNodeToDb = CCur(replace(Value, ".", DecimalSeparator))
  end select
end Function